type node = (int * char option);;
type 'a btree = 'a BinTree.t = Empty | Node of ('a btree * 'a * 'a btree);;
type t = node btree;;
type bits = int list
type freq = (char * int) Lst.t

val collate : char list -> freq
val combine : t list -> t list
val compress : string -> string -> unit
val decode : t -> bits -> Strng.t
val encode : (char * bits) Lst.t -> Strng.t -> bits
val expand : string -> string -> unit
val mknode : (char * int) -> t
val sample : Strng.t -> freq
val table : t -> (char * bits) Lst.t
val tree : freq -> t
