type 'a t = 'a list
val hd : 'a t -> 'a
val tl : 'a t -> 'a t
val append : 'a t -> 'a t -> 'a t
val init : 'a -> int -> 'a t
val take : int -> 'a t -> 'a t
val drop : int -> 'a t -> 'a t
val split_at : int -> 'a t -> 'a t * 'a t
val fold : ('a -> 'b -> 'b) -> 'b -> 'a t -> 'b
val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b t -> 'a
val filter : ('a -> bool) -> 'a t -> 'a t
val length : 'a t -> int
val map : ('a -> 'b) -> 'a t -> 'b t
val last : 'a t -> 'a
val nth : int -> 'a t -> 'a
val zip2 : 'a t -> 'b t -> ('a * 'b) t
val zip2_with : ('a -> 'b -> 'c) -> 'a t -> 'b t -> 'c t
val fold1 : ('a -> 'a -> 'a) -> 'a t -> 'a
val zip4 : 'a t -> 'b t -> 'c t -> 'd t -> ('a * 'b * 'c * 'd) t
val take_while : ('a -> bool) -> 'a t -> 'a t
val drop_while : ('a -> bool) -> 'a t -> 'a t
val span : ('a -> bool) -> 'a t -> 'a t * 'a t
val rev : 'a t -> 'a t
val until : ('a -> bool) -> ('a -> 'a) -> 'a -> 'a
val concat : 'a t t -> 'a t
